-- collision rectangle
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

-- collision circle (+ variable)
function CheckCollisionCircle(circleA, circleB,Vparam)
    local dist = (circleA.x - circleB.x)^2 + (circleA.y - circleB.y)^2
    return dist <= (circleA.radius + circleB.radius+Vparam)^2
end

-- end game
function exit_game()
	function love.keypressed(key)
	-- love.filesystem.write("user.sav", table.serialize(user,true,true))
		if key == "escape" and gs == 0 then			
			love.event.quit()
		end
		if key == "escape" and gs == 1 or gs == 2 or gs == 3 or gs == 4 then
			gs = 0					
		end		

		if key == "n" and gs == 1 then
			user.race = user.race + 100 				
		end				
	end
end

function autosavestat()
	if love.filesystem.exists("user.sav") then
		-- Load
		user = loadstring(love.filesystem.read("user.sav"))()
	else
		-- Save
		love.filesystem.write("user.sav", table.serialize(user,true,true))
	end
end

-- progress bar
function pbar (x,y,h,w,va,vm,info,c1,c2,c3,tpb)
	-- va = variable active
	-- vm = variable max	
	wm = w
	wa = va / vm * wm	
	
	love.graphics.setColor(c1,c2,c3,0.5)
	love.graphics.rectangle("fill", x, y, wm, h)
	
	love.graphics.setColor(c1,c2,c3,1)
	love.graphics.rectangle("fill", x, y, wa, h)
	if tpb == "/" then 		
		love.graphics.print(string.format(info), x,y-30)
		love.graphics.print(string.format(math.ceil(va)).."/"..string.format(math.ceil(vm)), x+w/2,y-30)
	end
	if tpb == "%" then
		love.graphics.print(string.format(info), x,y-30)
		love.graphics.print(string.format(math.floor(va)).."%", x+w/2,y-30)
	end
end

-- SENOID
function senoid(func,amp, freq, offset)
    amp = amp/2
    if func == 'sin' then
        return amp*math.sin(freq*varf) + offset + amp
    elseif func == 'cos' then
        return amp*math.cos(freq*varf) + offset + amp
    end
end

-- TABLE EMPTY
function table.empty (self)
    for _, _ in pairs(self) do
        return false
    end
    return true
end

-- TABLE LENGHT
function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

-- UNIQUE RND
function shuffle(tbl)
  size = #tbl
  for i = size, 1, -1 do        
	local rand = rng:random(size)    
	tbl[i], tbl[rand] = tbl[rand], tbl[i]
  end
  return tbl
end